require "sharpeye"

require 'Triangulator'
include System::Collections::Generic

class SerdceLoader < Loader

  #   feel(p) is invoked to determine - can this file load data or not?
  #
  #   p.ext // file extension in lower case, e.g. "dat"
  #   p.first_2k // first 2048 bytes of file data.
  #   p.first_lines // ascii presentation of first2k. If file contains \0, firstlines is cutted to that first \0.
  #   p.name // file name without extension
  #   p.path // full file path

  def self.feel(p) # Файл определяем по наличию "X Y Z" в первой строке
    p.first_lines.split(/\n/)[0].length == 73 and p.ext == "txt" ? 1.0 : 0.0
    # =~ /X\s+Y\s+Z/ ? 2.5 : 0.0
  end

  #   load(p) is invoked to load data, if this script is winner of feelings
  def load(p)

    m  = add_model( "#{p.name} serdce" )
    mis = add_model( "#{p.name} mishca" )
    mis.color_str = "red"
    mis.back_color_str = ""

    file = File.new( p.path , "r")

    n = 0
    nvec = 100
    merids = 10
    while ((pos = file.pos) and (line = file.gets))
#        puts line.unpack("a8a8a8a8a8a8a8").inspect
#        break
        gamma,psi,fi,x,y,z,vx,vy,vz = line.unpack("a8a8a8a8a8a8a8a8a8").map{ |e| e.to_f }
#        puts "#{vx} --- #{vy} --- #{vz}"

        m.add_sphere( x, y, z, 0.10, 3, 2 )
        n += 1
        #break if n > 30000
        puts "line #{n}" if n%1000 == 0
        if n%nvec == 0
#        if gamma == 0.001 #n%nvec == 0
#        if gamma == 0.0204 #n%nvec == 0
          origin = Point3D.new( x,y,z )
#          puts origin.inspect
          vec = Vector3D.new( vx,vy,vz )
#          puts vec.inspect

          mis.add_cylinder( origin, origin + vec, 0.05,true,merids )
          #mis.add_cone(origin + vec*1.3 ,origin + vec, 0.15,true,merids )
        end
    end
    file.close

    puts "Well done"
  end

end