namespace Contracts
{
    public interface ICameraTransformationController
    {
        void MoveCamera(ICameraWithMetaData cameraWithMetaData, MoveDirection direction, double distance);
        void RotateCamera(ICameraWithMetaData cameraWithMetaData, RotateDirection direction, double angle);
    }
    public enum MoveDirection
    {
        Forward,
        Backward,
        Left,
        Right,
        Up,
        Down
    }

    public enum RotateDirection
    {
        Left,
        Right,
        Up,
        Down,
        TiltLeft,
        TiltRight
    }
}