using System.ComponentModel;

namespace Contracts
{
    public interface IObjectWithMetaData : INotifyPropertyChanged
    {
        string Title { get; set; }
        bool Visible { get; set; }
        string Name { get; }
        event PropertyChangedEventHandler PropertyChanged;
    }
}