// ExeSample1.cpp:      .
//

#include "stdafx.h"
#include "string.h"
#include "stdlib.h"


int _tmain(int argc, _TCHAR* argv[])
{
	if (argc <= 1)
	{
		fprintf( stderr,"Usage: program.exe datafile [-F]\n" );
		return 0;
	}
	fprintf(stderr,"Exe filter started!\n");

	char *datafilename = argv[1];
	if (argc > 2 && strstr(argv[2],"-F") )
	{
		if (strstr(datafilename,".sample1"))
			printf( "1.0\n");
		else
			printf( "0.0\n");
		return 0;
	}

	FILE *f = fopen(datafilename,"rt");
	if (f == NULL)
	{
		fprintf(stderr,"File %s not found!\n",datafilename);
		return 1;
	}
	int num = 0;
	fscanf( f,"%d",&num );
	/// it seems it is our data
	printf("# generating %d items\n",num );
	//printf( "add_sphere_list\n" );
	//printf( "1,2,3,0.5,10,10\n");
	for (int i=0; i<num; i++)
	{
		int x = rand()%50 -25;
		int y = rand()%50 -25;
		int z = rand()%50 -25;
		printf( "add_node %d,%d,%d\n",x,y,z );
		printf( "add_node %d,%d,%d\n",x,y+1,z );
		printf( "add_node %d,%d,%d\n",x,y+1,z+1 );
		printf( "add_triangle_trusted %d,%d,%d\n",3*i,3*i+1,3*i+2 );

		//printf( "%d,%d,%d,0.5,10,10\n",i,i,i );
	}
/*
	for (int i=0; i<num; i++)
	{
		printf( "add_sphere %d,%d,%d,0.5,10,10\n",rand()%50-25,rand()%50-25,rand()%50-25 );
		//printf( "%d,%d,%d,0.5,10,10\n",i,i,i );
	}
*/
	//printf("end\n" );
	printf("done!\n" );
	fflush(stdout);

	char buf[512];
	fprintf(stderr,"Waiting some interactive...\n");
	fgets(buf,500,stdin );
	fprintf(stderr,"Got it!\n");

	return 0;
}

