﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using Visualizator;
using Contracts;
using System.Windows.Media.Media3D;


namespace ExternalUserApp
{
    class Program
    {
        [STAThread]
        static void Main(string[] args)
        {
            System.Windows.Application application = new System.Windows.Application();
            MainWindow window = new MainWindow();
            application.MainWindow = window;
            window.Show();

            IStorage s = Visualizator.MainWindow.TheStorage;
            IModel3DWithMetaData m = s.AddModel("kva");
            m.AddSphere(2, 2, 0, 1);
            m.FinalizeConstruction();
            m.Refresh();

            window.MakeMainViewVisible();

            application.Run();
        }
    }
}
