puts "Executing boot.rb"

# $LOAD_PATH.unshift File.expand_path(File.dirname(__FILE__))
# $LOAD_PATH.unshift "."

require "set" # must be here, because does not work later

# File.join( File.expand_path( File.dirname(__FILE__) ), "sharpeye.rb" )
require "sharpeye"

require "hotkeys"

# Auto-load loaders/etc
roots = [File.join(sharpeye_root,"scripting")] + Dir.glob( File.join(sharpeye_root,"scripting","*") ).delete_if{ |p| not File.directory?(p) or p =~ /\.system/ }

for dir in roots
  for p in Dir.glob( File.join(dir,"*.rb") )
    # skip .system dir # next if p =~ /\.system/
    puts "Loading file #{p}"
    require p
    # importer.add_ruby_filter( p )
  end
end


# Attach loaders to SharpEye
Loader.subclasses.each do |ka|
  puts "Adding ruby loader #{ka.name}"
  $importer.add_ruby_loader( ka )  
end

# for p in Dir.glob( File.join(sharpeye_root,"scripting","ExeFilters","*.exe") )  
#   puts "Installing exe proxy plugin for #{p}"
#   importer.add_ruby_filter( "Scripting/EyeFormat/exeloader.rb",p ) 
# end

if false
puts "Loading evented lib"
require File.join(sharpeye_root,"scripting",".system","evented","event_pusher.rb")
Evented::EVENTS_PREFIX = "sharpeye/"
Evented::PUSH_MODE = :local_log
puts "Loaded. Pushing startup event"
Evented.push("start",1)
end

puts "Boot.rb done. Calling init.rb in root."
require File.join(sharpeye_root,"init.rb")