# encoding: utf-8
puts "Loading web server...."

$LOAD_PATH.unshift File.expand_path(File.dirname(__FILE__))

require "rubygems"
require 'sinatra/base'
require "reloader"
#require 'ftools'
                 
class MyApp < Sinatra::Base
  configure :development do
    register Sinatra::Reloader
  end

  FILES_DIR = File.join( File.expand_path(File.dirname(__FILE__)),"public","cheleye" )

  def self.log(msg)
    defined?($logger) ? $logger.info(msg) : puts(msg)
  end
  def log(msg)
    self.class.log(msg)
  end

  get '/' do
    log "got index request"
    erb :eindex
  end

  post '/cheleye/create' do
    log "Got /cheleye/create post request"
    #log request.inspect
    #log params.inspect
    if params[:thefile].nil?
      log "params[:thefile] is empty!"

      return [500,"Please specify input data file!"]
    end
    log params[:thefile][:tempfile].path
    
    id = Time.now.strftime( "%Y-%m-%d_%H-%M-%S_" ) + request.ip
                     
    tdir = File.join(FILES_DIR,id)
    while File.exist?( tdir )
      id = id + "x2"
      tdir = File.join(FILES_DIR,id)
    end

    #FileUtils.mkdir("public")
    FileUtils.makedirs( tdir )
    tfile = File.join(tdir,params['thefile'][:filename])
    argline = ""
     
    File.open(tfile, "w") do |f|
      f.write(params['thefile'][:tempfile].read)
    end

    argline << " #{tfile}"

    if params[:script]
      s = if params[:script].is_a?(String)
        params[:script]
      else
        params[:script][:tempfile].readlines.join("\n")
      end
      sfile = File.join(tdir,"script.rb") 
      File.open(sfile, "w") do |f|
        f.write(s)
      end
      #$engine.load_data( sfile )
      argline << " #{sfile} "
    end

    ssfile = File.join(tdir,"shot.rb")
    File.open(ssfile, "w") do |f|
        shotfile = File.join(tdir,"result.jpg")
        f.write("$engine.save_screen_shot_to_file( \"#{shotfile}\" )\n$engine.close" )
    end
    argline << " #{ssfile}"

    #runstr = "Visualizator.exe #{argline}"

    vdir = File.expand_path( File.join( File.dirname(__FILE__),"..","..",".." ) )
    
    # WARNING! This is very intellectual code!
    # `psexec -i` runs program in session 0, e.g. console session. 
    # This means that WPF will work in Remote Desktop environment even after user disconnection! EEE!
    thisdir = File.expand_path File.join( File.dirname(__FILE__) )
#    runstr = "#{thisdir}/PsExec.exe -d -i -u Administrator -p Password1 -w #{vdir} #{vdir}/Visualizator.exe #{argline}"
# -x = winlogon
# -i = interactive, mabe -i 1 = logged on user..? (i think same as -i)
# -s = system account
# lets try...
#    runstr = "#{thisdir}/PsExec.exe -d -s -x -i -w #{vdir} #{vdir}/Visualizator.exe #{argline}" #WORKS!
#    runstr = "#{thisdir}/PsExec.exe -d -i 1 -u Administrator -p Password1 -w #{vdir} #{vdir}/Visualizator.exe #{argline}"
    WIN2003MODE = false
    if WIN2003MODE
      runstr = "#{thisdir}/PsExec.exe -d -i -w #{vdir} #{vdir}/Visualizator.exe #{argline}"
    else
      runstr = "Visualizator.exe #{argline}"
    end

    log "Spawning: #{runstr}" #in dir #{vdir}"
    pid = spawn(runstr, :chdir=>vdir)

    log "Finishing web request and returning id #{id}"

    if params[:gui]
      redirect "/cheleye/#{id}/pending",302
    else
      id.to_s
    end
  end

  get '/cheleye/:id/pending' do
   id = params[:id]
   tdir = File.join(FILES_DIR,id)
   shotfile = File.join(tdir,"result.jpg")
   if File.exist?( shotfile )
     redirect "/cheleye/#{id}/done",302
   else
     erb :pending
   end
  end

  get '/cheleye/:id/done' do
    @id = id = params[:id]
    tdir = File.join(FILES_DIR,id)
    
    sfile = File.join(tdir,"script.rb") 
    @scripta = File.open(sfile, "r") do |f|
        f.readlines.join("")
      end rescue nil
    erb :eindex
  end

end

puts "Web server started"
MyApp.run! :port => 9001
