#@t = Thread.new do
puts "Loading web server...."

$LOAD_PATH.unshift File.expand_path(File.dirname(__FILE__))

require "rubygems"
require 'sinatra/base'
require "reloader"
#require 'ftools'
                 
class MyApp < Sinatra::Base
  configure :development do
    #register Sinatra::Reloader
  end

  FILES_DIR = File.join( File.expand_path(File.dirname(__FILE__)),"public","cheleye" )

  def self.log(msg)
    defined?($logger) ? $logger.info(msg) : puts(msg)
  end
  def log(msg)
    self.class.log(msg)
  end

  get '/' do
    log "got index request"
    erb :index
  end

  get '/cheleye/:id/gui' do
    @id = params[:id]
    erb :index
  end

  post '/cheleye/create' do
    log "Got /cheleye/create post request"
    log params.inspect
    log params[:thefile][:tempfile].path
    
    id = Time.now.to_i.to_s

    return "lalla"
    
    tdir = File.join(FILES_DIR,id)
    #FileUtils.mkdir("public")
    FileUtils.makedirs( tdir )
    tfile = File.join(tdir,params['thefile'][:filename])
     
    File.open(tfile, "w") do |f|
      f.write(params['thefile'][:tempfile].read)
    end

    #meth = proc { |status| $scene.reset_and_init }
    #$engine.dispatcher.invoke System::Action.of(String).new(&meth), "jo"
                                                                                              
    $engine.dispatcher.invoke System::Action.new( proc { $scene.reset_and_init } )
    $engine.load_data( tfile )

    if params[:script]
      s = if params[:script].is_a?(String)
        params[:script]
      else
        params[:script][:tempfile].readlines
      end
      sfile = File.join(tdir,"script.rb") 
      File.open(sfile, "w") do |f|
        f.write(s)
      end
      $engine.load_data( sfile )
    end
    
    shotfile = File.join(tdir,"result.jpg")
    $engine.save_screen_shot_to_file( shotfile )

    if params[:gui]
      @id = id
      #erb :index
      log "Redirecting to gui version, /cheleye/#{id}/edit"
      log "test 1"
      redirect "/cheleye/#{id}/edit",302
      log "test 2"
      #redirect 'http://ur.ru'
    else  
      log "Finishing web request and returning id #{id}"
      id
    end
    log "Response body is"
    log response.body
    id.to_s
  end 

# no need
#  get '/cheleye/:id.jpg' do
#    tdir = File.join(FILES_DIR,params[:id])
#    shotfile = File.join(tdir,"result.jpg")
#    if File.exist?( shotfile ) 
#      send_file(shotfile, :disposition => 'inline', :type => 'image/jpeg')
#    else
#      halt 404,"image not ready"
#    end
#  end
                            
  get '/shot' do
    # Hey, I'm no longer in the application scope!
    #foo.to_s
    f = "cheleye.jpg"
    $engine.SaveScreenShotToFile(f)
    send_file(f, :disposition => 'inline', :type => 'image/jpeg')
    #43.to_s 
  end

 # run!
end

puts "Web server started"
MyApp.run! :port => $0==__FILE__ ? 9000 : 9000

#end # thread
                         

#@t = nil

if $0==__FILE__
  #@t.join
  #MyApp.run! :port => 9001
else
  #@t = Thread.new do
  #  MyApp.run! :port => 9000
  #end 
end

#def start
#end

#def finish
#  puts "Terminating web server...."
#  @t.exit
#  sleep 5
#  puts "Done"
#end