# Неудавшаяся попытка загружать DCM-файлы. См. hehe.png

$LOAD_PATH.unshift File.expand_path(File.dirname(__FILE__))
# $LOAD_PATH.unshift "."

require "read_zub.rb"
require "base64"

class ZubDcmLoader < ZubLoader

  #   feel(p) is invoked to determine - can this file load data or not?
  #
  #   p.ext // file extension in lower case, e.g. "dat"
  #   p.first_2k // first 2048 bytes of file data.
  #   p.first_lines // ascii presentation of first2k. If file contains \0, firstlines is cutted to that first \0.
  #   p.name // file name without extension
  #   p.path // full file path

  def self.feel(p)
    p.ext == "dcm" ? 1.0 : 0.0
  end

  def load(p)
    @m = add_model( p.name )

    f = File.new( p.path , "r")
    while line=f.gets
      if line =~ /<Vertices vertex_count="(\d+)".*>(.+)<\/Vertices>/
        n = $1.to_i
        enc = $2
        puts "encoded:"
        puts enc[0..500]
        puts ",............................"
        puts enc[-500..-1]                        
        plain = Base64.decode64(enc)
        puts "vertices count=#{n}, bytelen=#{plain.length}:"
        puts plain[0..500]
        points = plain[0..(-4)].unpack("f*")
        puts "vertices floats, len=#{points.length}:"
        puts points[0..100].inspect
      end
      if line =~ /<Facets facet_count="(\d+)".*>(.+)<\/Facets>/
        n = $1.to_i
        enc = $2
        plain = Base64.decode64(enc)
        puts "encoded:"
        puts enc[0..500]        
        puts ",............................"
        puts enc[-500..-1]                
        puts "facets count=#{n}, bytelen=#{plain.length}:"
#        puts plain[0..500]
        puts plain
      end
    end

    after_load(p)
  end
  
end