# sample : tseries_u.dat 

class RubinaTSeriesLoader < Loader

# include System::Collections::Generic

  def self.feel(p)
    float="[-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?"
    tp="\w+\d+\s*="
    p.first_lines =~ /^\s*\w+(\s+\w+\d+\s*=.+){2,}/ ? 1.0 : 0.0
  #  p.first_lines =~ /^\s*\w+\s+#{tp}\s+#{tp}/ ? 1.0 : 0.0
  #  p.first_lines =~ /^\s*\w+\s+/ ? 1.0 : 0.0
  end

  def load(p)
    file = File.new( p.path , "r")
    vars = file.gets.strip.split(/\s+/)

    group = scene.add_group( "#{p.name_ext} series" )

    tnum = vars.length-1
    tvals = []
    models = []
    for i in (1..tnum) do
        tt = vars[i]
        models << add_model( tt,"",true,group )
        tt =~ /^.+=(.+)$/
        tvals << $1.to_f
    end

    tseriesprev = Array.new(tnum)
    lcount=0
    while ((pos = file.pos) and (line = file.gets))
      lcount=lcount+1
      items = line.strip.split(/\s+/)
      x = items[0].to_f
      for i in (1..tnum) do
       # void AddBox(Point3D center, double xLength, double yLength, double zLength);
        r = 0.05
        t = items[i].to_f
        pt = Point3D.new(x, tvals[ i-1 ], t)
        #models[i-1].add_cube( pt, r )
        models[i-1].add_box( pt, r,r,r )
        if lcount > 1
          models[i-1].add_line( tseriesprev[i-1], pt, 0.015, 6 )
        end
        tseriesprev[i-1] = pt
      end
    end

    return
  end

end
