require "sharpeye"

require 'Triangulator'
include System::Collections::Generic

class SerdceDynamicLoader < Loader

  #   feel(p) is invoked to determine - can this file load data or not?
  #
  #   p.ext // file extension in lower case, e.g. "dat"
  #   p.first_2k // first 2048 bytes of file data.
  #   p.first_lines // ascii presentation of first2k. If file contains \0, firstlines is cutted to that first \0.
  #   p.name // file name without extension
  #   p.path // full file path

  def self.feel(p) # Файл определяем по наличию "X Y Z" в первой строке
    p.first_lines.split(/\n/)[0].length == 43 and p.ext == "txt" ? 1.0 : 0.0
    # =~ /X\s+Y\s+Z/ ? 2.5 : 0.0
  end

  #   load(p) is invoked to load data, if this script is winner of feelings
  def load(p)

    m  = add_model( "#{p.name} serdce dynamic" )

    file = File.new( p.path , "r")

    n = 0
    while ((pos = file.pos) and (line = file.gets))
        #gamma,psi,fi,x,y,z = line.unpack("a6a7a7a9a7a7").map{ |e| e.to_f }
        gamma,psi,fi,x,y,z = line.strip.split(/\s+/).map{ |e| e.to_f }
        # puts "#{n}: #{gamma} -- #{psi} -- #{fi} -- #{x} -- #{y} -- #{z}" if rand(300)==0
#        break

        m.add_sphere( x, y, z, 0.10, 3, 2 ) if n % 10 == 0
        n += 1
        #break if n > 300000
        puts "line #{n}" if n%1000 == 0
    end
    file.close

    puts "Well done"
  end

end