class Setki1Loader < Loader

  # require 'WindowsBase'
  # include System::Windows

  #   feel(p) is invoked to determine - can this file load data or not?
  #
  #   p.ext // file extension in lower case, e.g. "dat"
  #   p.first_2k // first 2048 bytes of file data.
  #   p.firstlines // ascii presentation of first2k. If file contains \0, firstlines is cutted to that first \0.
  #   p.name // file name without extension
  #   p.path // full file path
  def self.feel(p)
  #  puts "Invoked feel, path #{p.path}, first lines #{p.first_lines}"
    p.first_lines =~ /TITLE.+VARIABLES.+ZONE/mi ? 2.75 : 0.0
  end

  #   load(p) is invoked to load data, if this script is winner of feelings
  def load(p)
    puts "We are loading..."
    counter = zcounter = 0
    file = File.new( p.path , "r")
    group = scene.add_group( p.name + " points" )
    tmin = 100000000
    tmax = -100000000

    while (line = file.gets)
      items = line.strip.split(/\s+/) [0..3]
      next if items.length == 0
      vals = items.map{ |i| i.to_f*10 }
      if items[0] =~ /ZONE/ #and zcounter == 0
        m = add_model(p.name+"\\block #{zcounter=zcounter+1} points", nil, true, group )
        ## scene.set_model_group(m,group)
        m.color_str = ["red","green","blue","#00cccc","#aa33cc","#1f7"][zcounter % 6]
      end
  #    puts "vals are #{vals.inspect}"
      if vals[0] > 0 or vals[1] > 0 or vals[2] > 0
        counter = counter +1
        if t = vals[3]
          m.color_value = t
  # System::Windows::Point.new(t,0)
          tmin = t if t < tmin
          tmax = t if t > tmax
  #        m.add_sphere( vals[0], vals[1], vals[2], t/100.0, 3, 2 ) #if t > 10
           puts "Loaded #{counter} points" if counter % 1000 == 0
           m.add_sphere( vals[0], vals[1], vals[2], 0.10, 3, 2 )
        else
          m.add_sphere( vals[0], vals[1], vals[2], 0.05, 3, 2 )
        end
    #    CubeFilter::CubeFilter::GenerateCube(m, vals[0], vals[1], vals[2], 0.05);
      end
    end
    file.close

    created_models.each{ |mm|
    mm.set_color_table( 0.33 => "blue", 0.65 => "green", 1 => "red" );
  #    mm.set_color_table( 0 => "blue", 0.5 => "green", 1 => "red" );
  #    mm.set_color_table( 0 => "black", 0.3 => "green", 1 => "red" );
    mm.set_color_range(tmin,tmax)
  #    mm.set_color_range(8,15)
    }

    puts "#{counter} points, #{zcounter} zones, tmin = #{tmin}, tmax = #{tmax}"
  end

end