require 'Triangulator'
#include Visualizator::Triangulator
include System::Collections::Generic

class TimofeySurfaceLoader < Loader

  #   feel(p) is invoked to determine - can this file load data or not?
  #
  #   p.ext // file extension in lower case, e.g. "dat"
  #   p.first_2k // first 2048 bytes of file data.
  #   p.first_lines // ascii presentation of first2k. If file contains \0, firstlines is cutted to that first \0.
  #   p.name // file name without extension
  #   p.path // full file path

  def self.feel(p)
    float="[-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?"
    p.first_lines =~ /^\d+\r\s*#{float}\s+#{float}\s+#{float}\s+#{float}\s+#{float}\s+#{float}/ ? 0.99 : 0.0
  end

  #   load(p) is invoked to load data, if this script is winner of feelings
  def load(p)
    m = add_model( "#{p.name} points" )

    file = File.new( p.path , "r")
    n = file.gets

  #  vertices = List.of(Triangulator::Geometry::Point).new

    vals = file.gets.split(" ")
    i = 0
    while i < vals.length do
      m.add_sphere(vals[i],vals[i+1],vals[i+2],0.01,3,2)
      i=i+3
    end

  #  while ((pos = file.pos) and (line = file.gets))
  #      items = line.strip.split(/\s+/) [0..2]
  #      next if items.length == 0
  #      x,y,z = items.map{ |i| i.to_f }
  #      # puts "Got items: #{items.inspect}, so xyz is #{x} #{y} #{z}"
  #
  #      m.hit_value = pos #vertices.count
  #      m.add_sphere( x, y, z, 0.10, 3, 2 )
  #      vertices << Triangulator::Geometry::Point.new(x,y,z)
  #  end

  #  puts "Triangulating #{vertices.count} nodes"
  #  tris = Triangulator::Delauney::Triangulate(vertices)
  #  puts "We got #{tris.count} triangles"

  #  m2 = add_model( "#{p.name} surface" )
  #  vertices.each{ |v| m2.add_node( v.X, v.Y, v.Z ) }
  #  tris.each{ |t| m2.add_triangle( t.p2, t.p1, t.p3 ) }

  #            List<Triangulator.Geometry.Triangle> tris = Triangulator.Delauney.Triangulate(Vertices);

    m.hit_tested do |sender, args|
  #    file.seek( sender.hit_value, IO::SEEK_SET)
  #    puts "File #{p.name} offset #{sender.hit_value+1}: #{file.gets}"
  #    puts "Hello there, sender is #{sender.inspect}, args are #{args.inspect}"
    end

    puts "Well done"
  end

end