#require 'Visualizator'

#SHARPEYE_ROOT = sharpeye_root

#load_assembly 'IronRuby.Libraries'
load_assembly 'PresentationCore' 
load_assembly 'PresentationFramework' 

include System::Windows::Media::Media3D #for Point3D

def puts(msg)
#  Visualizator::Logger.Info( msg )
#  @logger ||= logger_var.class
#  defined?(logger) ? logger.info(msg) : super
#  logger.info(msg) rescue puts(msg)
  logger.info(msg.to_s)
end

def progress(percent)
#  Visualizator::Logger.Info( msg )
#  @logger ||= logger_var.class
  logger.progress percent
end

def add_model(name,desc="",visible=true,parent_group=nil)
  m = scene.add_model(name,desc,visible,parent_group)
  @models_list ||= []
  @models_list << m
  @current_model = m
  create_default_model_methods if @current_model_methods_created != true
  m
end

def created_models
  @models_list || []  
end

def reset_created_models
  @models_list = nil
  @current_model = nil
end

def finalize_models
  created_models.each{ |m| 
    m.finalize_construction
    m.refresh
  }
end

def register_filter
  puts "Invoked register_filter on #{self}"
end                              
class Filter
  def self.register_filter
    puts self
  end
end

#module Filter
#  def self.included(base)
#    STDOUT.puts base
#  end
#end

#class Bla 
#  include Filter
#end

# class Bla < Filter
#  register_filter
#  
# end

# hehe, we undef standard load method
undef load


## Default models

# from http://blog.jayfields.com/2008/02/ruby-replace-methodmissing-with-dynamic.html
def create_default_model_methods
  logger.info "Invoked create_default_model_methods ##start"
  @current_model.public_methods(false).each do |meth|
      (class << self; self; end).class_eval do
        define_method meth do |*args|
          @current_model.send meth, *args
        end
      end
    end
  logger.info "Invoked create_default_model_methods ##done"
  @current_model_methods_created = true
end


#def method_missing(meth, *args, &block)
#  super
#end

#def method_missing(meth, *args, &block)
#  if @current_model and @current_model.respond_to(meth)
#self.class.class_eval <<-end_eval
#  def #{meth}(*args, &block)
#    @current_model.__send__(:#{meth}, *args, &block)
#  end
#end_eval
#__send__(meth, *args, &block)
#  else
#    super 
#  end
#end


